defmodule ElixirRss.FeedUpdater do
  use GenServer

  def start_link(opts) do
    GenServer.start_link(__MODULE__, %{}, opts)
  end

  def get_state(server, url) do
    GenServer.call(server, {:get, url})
  end

  def update(server, url) do
    GenServer.call(server, {:update, url})
  end


  @impl true
  def init(state) do
    {:ok, state}
  end

  @impl true
  def handle_call({:get, url}, _from, state) do
    {:reply, Map.get(state, url), state}
  end

  @impl true
  def handle_call({:update, url}, _from, state) do
    new_model = ElixirRss.Fetcher.fetch_model(url)
    new_state = Map.put(state, url, new_model)
    {:reply, :ok, new_state}
  end
end
